#pragma hdrstop

#include "OADOPlugin.h"

#pragma package(smart_init)

using namespace OADOPlugin;

__fastcall CPlugin::CPlugin(AdapterClass* const Adapter):
           OPlugin::CPluginTmp<AdapterClass>(Adapter, Adapter->MainForm())
{
    TForm *Main = Callback->MainForm();
    Top = Main->Top + Main->Height + 2;
    Left = 0;
    Width = Screen->Width;
    Height = Screen->WorkAreaHeight - Top - 2;
}

__fastcall CPluginDialog::CPluginDialog(AdapterClass* const Adapter):
           OPlugin::CPluginDialogTmp<AdapterClass>(Adapter, Adapter->MainForm())
{
    HMENU SysMenu = GetSystemMenu(Handle, false);
    EnableMenuItem(SysMenu, SC_CLOSE, MF_DISABLED | MF_GRAYED);
}

CPluginHandle::CPluginHandle(HINSTANCE DllHandle,
                             AnsiString DllName,
                             PluginClass* const Plugin):
                             OPlugin::CPluginHandleTmp<PluginClass>(DllHandle, DllName, Plugin)
{
}

CPluginTable::CPluginTable()
{
    ClassName = "OADOPlugin::CPluginTable";
}

CPlugins::CPlugins(const RegisterPluginFunctionPointer PRegister,
                   const UnregisterPluginFunctionPointer PUnregister,
                   AdapterClass* const Adapter):
                   OPlugin::CPluginsTmp<PluginTableClass>(PRegister, PUnregister, Adapter)
{
    ClassName = "OADOPlugin::CPlugins";
}
