#ifndef OADOPluginH
#define OADOPluginH

#include "OPlugin.h"
#include "OADOAdapter.h"

namespace OADOPlugin
{
    using namespace OADOAdapter;

    //extern const char *g_szPluginTable;
    //extern const char *g_szPlugins;

    class PACKAGE CPlugin: public OPlugin::CPluginTmp<CAdapter>
    {
    public:
        __fastcall CPlugin(AdapterClass* const Adapter);
    };

    class PACKAGE CPluginDialog: public OPlugin::CPluginDialogTmp<CAdapter>
    {
    public:
        //Adapter;
        __fastcall CPluginDialog(AdapterClass* const Adapter);
    };

    class PACKAGE CPluginHandle: public OPlugin::CPluginHandleTmp<CPlugin>
    {
    public:
        CPluginHandle(HINSTANCE DllHandle,
                      AnsiString DllName,
                      PluginClass* const Plugin);
    };

    class PACKAGE CPluginTable: public OPlugin::CPluginTableTmp<CPluginHandle>
    {
    public:
        CPluginTable();
    };

    class PACKAGE CPlugins: public OPlugin::CPluginsTmp<CPluginTable>
    {
    public:
        CPlugins(const RegisterPluginFunctionPointer,
                 const UnregisterPluginFunctionPointer,
                 AdapterClass* const);
    };
}

#endif
